% 
%  V1 = 0.888;
%  V2 = 0.112;
 V1 = 0.8;
 V2 = 0.2;

% %%%%%%%%%%%%% MD potential
% E_FE = Tensor(213,143,119);
% S_FE = Reverse(pinv(Transform9(E_FE)));
% E_CE = [335 174 122 0 0 0 0 0 0;
%         174 328 138 0 0 0 0 0 0;
%         122 138 231 0 0 0 0 0 0;
%         0 0 0 86 0 0 86 0 0;
%         0 0 0 0 22 0 0 22 0;
%         0 0 0 0 0 105 0 0 105;
%         0 0 0 86 0 0 86 0 0;
%         0 0 0 0 22 0 0 22 0;
%         0 0 0 0 0 105 0 0 105];
% S_CE = Reverse(pinv(E_CE));
%%%%%%%%%%%%%%%%%%%%%%%%% Material project
E_FE = Tensor(213,143,119);
S_FE = Reverse(pinv(Transform9(E_FE)));
E_CE = [326 163 119 0 0 0 0 0 0;
        163 303 135 0 0 0 0 0 0;
        119 135 249 0 0 0 0 0 0;
        0 0 0 72 0 0 72 0 0;
        0 0 0 0 27 0 0 27 0;
        0 0 0 0 0 98 0 0 98;
        0 0 0 72 0 0 72 0 0;
        0 0 0 0 27 0 0 27 0;
        0 0 0 0 0 98 0 0 98];
S_CE = Reverse(pinv(E_CE));
% E_CE = Tensor(213,143,119);
% S_CE = Reverse(pinv(Transform9(E_CE)));


V1_3 = [1 -1 0];
V1_1 = [1 1 1];
V1_2 = [-1 -1 2];
V1_1 = V1_1/norm(V1_1);
V1_2 = V1_2/norm(V1_2);
V1_3 = V1_3/norm(V1_3);
Ori_FE = [V1_1;V1_2;V1_3]; % Here is the miller indices, the global X,Y,Z in local CS.
% The local X,Y,Z in global CS is Ori_FE'.

V2_3 = [1 0 0];
V2_1 = [0 1 0];
V2_2 = [0 0 1];
V2_1 = V2_1/norm(V2_1);
V2_2 = V2_2/norm(V2_2);
V2_3 = V2_3/norm(V2_3);
Ori_CE = [V2_1;V2_2;V2_3];
S_FE_rot = F_rotate_compliance_by_matrix(S_FE,Ori_FE);
S_CE_rot = F_rotate_compliance_by_matrix(S_CE,Ori_CE);
Sigma = [0 0 0; 0 1 0;0 0 0]';
Pole_plot = [];
Extreme = [];
t1 = -90;
RSS_list = [];
for t2 = 0:1:180

v_origin = [0;1;0];
% Define the rotation matrix for rotation around Z-axis by angle phi
Rz = [cosd(t1), -sind(t1), 0;
      sind(t1),  cosd(t1), 0;
      0,        0,        1];

% Define the rotation matrix for rotation around Y-axis by angle theta
Ry = [cosd(t2),  0, sind(t2);
      0,          1, 0;
     -sind(t2), 0, cosd(t2)];

% Combined rotation matrix: first rotate by phi around Z, then by theta around Y
R = Ry * Rz;

% Rotate the stress tensor
v_final = R * v_origin;

loc = F_vector2pole_XOZ(v_final);
Sigma_local = R * Sigma *R';

Sigma_local_voigt = [Sigma_local(1,1),Sigma_local(2,2),Sigma_local(3,3),Sigma_local(2,3),Sigma_local(1,3),Sigma_local(1,2)];

[Stress1,Stress2,Strain1,Strain2] = F_IncStressStrain_Volume(Sigma_local_voigt,S_FE_rot,S_CE_rot,V1,V2);

Stress_Fe = [Stress1(1),Stress1(6),Stress1(5);Stress1(6),Stress1(2),Stress1(4);Stress1(5),Stress1(4),Stress1(3)];
Stress_Ce = [Stress2(1),Stress2(6),Stress2(5);Stress2(6),Stress2(2),Stress2(4);Stress2(5),Stress2(4),Stress2(3)];
Stress_Fe_local = Ori_FE' * Stress_Fe * Ori_FE;
Stress_Ce_local = Ori_CE' * Stress_Ce * Ori_CE;

% Fe_slip_planes = [1 1 0; 1 1 0; 1 -1 0;1 -1 0;1 -1 -2;1 0 1;1 0 1];
% Fe_slip_directions = [-1 1 1;1 -1 1;1 1 1;1 1 -1;1 -1 1;-1 1 1;1 1 -1];
Fe_slip_planes = [1 1 0; 1 1 0; 1 -1 0;1 -1 0;1 -1 -2;1 0 1;1 0 1;1 2 1];
Fe_slip_directions = [-1 1 1;1 -1 1;1 1 1;1 1 -1;1 -1 1;-1 1 1;1 1 -1;1 -1 1];

norms_slipdirection = vecnorm(Fe_slip_directions, 2, 2);
norms_slipplanes = vecnorm(Fe_slip_planes, 2, 2);

normalized_slip_directions = Fe_slip_directions ./ norms_slipdirection;
normalized_slip_planes = Fe_slip_planes ./ norms_slipplanes;

Num = size(Fe_slip_planes,1);
rss = zeros(1,Num);
for i = 1:Num
    m_cross_n = normalized_slip_planes(i,:)' * normalized_slip_directions(i,:);
    rss(i) = sum(sum(Stress_Fe_local .* m_cross_n));
end
RSS_list = [RSS_list;abs(rss)];
end
% Ce_slip_planes = [0 1 1; 3 0 1; 1 0 1; 2 0 -1; 0 3 1; 0 2 1];
% Ce_slip_planes(:,1) = Ce_slip_planes(:,1) * 4.47;
% Ce_slip_planes(:,2) = Ce_slip_planes(:,2) * 5.088;
% Ce_slip_planes(:,3) = Ce_slip_planes(:,3) * 6.67;
% Ce_slip_directions = [1 0 0;0 1 0;0 1 0; 0 1 0; 1 0 0; 1 0 0];
% 
% norms_slipdirection = vecnorm(Ce_slip_directions, 2, 2);
% norms_slipplanes = vecnorm(Ce_slip_planes, 2, 2);
% 
% normalized_slip_directions = Ce_slip_directions ./ norms_slipdirection;
% normalized_slip_planes = Ce_slip_planes ./ norms_slipplanes;
% 
% Num = size(Ce_slip_planes,1);
% rss = zeros(1,Num);
% for i = 1:Num
%     m_cross_n = normalized_slip_planes(i,:)' * normalized_slip_directions(i,:);
%     rss(i) = sum(sum(Stress_Ce_local .* m_cross_n));
% end
% RSS_list = [RSS_list;abs(rss)];
% end